--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   09:43:00 11/04/2013
-- Design Name:   
-- Module Name:   /export/dsk13/njarvis/findtime/findtime_tb.vhd
-- Project Name:  findtime
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: findtime
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
--use work.findtime_pack.all;
 
ENTITY findtime_tb IS
END findtime_tb;
 
ARCHITECTURE behavior OF findtime_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT findtime
    PORT(
         clk : IN  std_logic;
         go : IN  std_logic;
         reset: in std_logic;          -- reset when high
         adc : IN  std_logic_vector (11 downto 0);
         
         busy: out std_logic;          -- busy when high - several clock cycles
         completed: out std_logic;          -- done when high - one clock cycle
        
         le_time : out std_logic_vector (13 downto 0);
         q_code: out std_logic_vector (2 downto 0);

         state_code: out std_logic_vector (5 downto 0)
        );
    END COMPONENT;
    
   --Inputs
	
    signal clk : std_logic := '0';
    signal reset : std_logic := '0';
    signal start : std_logic := '0';
	-- run 32488 event 15 channel 27 xthr is 133 newped 38.6 localped 48.3 le_bin 130.04
	-- 5sig thres is 38 + 5*16 = 118
	-- later on, read these in from a file
	-- xthr is 133 pedlead is 3 and need 5 extrs so start with sample 125
	-- starting with sample 125 ??
	-- xthr should 
	-- 65, 62, 56, 46,41,56,85,109,120,122,127,150,181,197,193,173,157,149,143,139
	
    signal adc : std_logic_vector(11 downto 0) := (others => '0');
	
 	--Outputs
    signal busy : std_logic := '0';  -- busy calculating
    signal completed : std_logic := '0';  -- finished calculating
    signal le_time :  std_logic_vector (13 downto 0) := (others=>'0');
    signal q_code:  std_logic_vector (2 downto 0) := (others=>'0');
    signal state_code:  std_logic_vector (5 downto 0) := (others=>'1');

   -- Clock period definitions
    constant clk_period : time := 1 ns;
	
    constant ADCBUFFERMAX: integer := 14;  -- buffer array indices 0 to ADCBUFFERMAX
	
    type iadcarray is array (natural range <>) of integer range 0 to 4095;
    constant ADCVAL: iadcarray(0 to ADCBUFFERMAX) := 
		(60, 63, 65, 62, 56, 46,41,56,85,109,120,122,127,150,181); --,197,193,173,157,149,143,139);

BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: findtime PORT MAP (
          clk => clk,
          go => start,
          reset => reset,
          adc => adc,
          busy => busy,
          completed => completed,
          le_time => le_time,
          state_code => state_code,
          q_code => q_code
        );

   -- Clock process definitions
   clk_process :process
   begin
     clk <= '0';
     wait for clk_period/2;
     clk <= '1';
     wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		

	wait for clk_period;
	wait for clk_period/2;
	
	start <= '1';
	wait for clk_period;
        start <= '0';
        
	feed1: for i in 0 to ADCBUFFERMAX loop
		adc <= std_logic_vector(to_unsigned(ADCVAL(i),12));
                wait for clk_period;
	end loop;

      	wait for clk_period*100;

        report "received le time " & integer'image(to_integer(unsigned(le_time)));

        reset <= '1';

	wait for clk_period;

        reset <= '0';
        wait;

     

   end process;

END;
